unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SKHeapSort, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox2: TListBox;
    SKHeapSort1: TSKHeapSort;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function SKHeapSort1SortLess(Index1, Index2: Integer): Boolean;
    procedure SKHeapSort1SortSwap(Index1, Index2: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TheList : TStringList;
implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
 Var
  I : Integer;
begin
  For I := 0 To 10 Do
   Begin
    ListBox1.Items.Add('Hello');
    TheList.Add('Hello');
    ListBox1.Items.Add('There');
    TheList.Add('There');
    ListBox1.Items.Add('You');
    TheList.Add('You');
    ListBox1.Items.Add('Dumb');
    TheList.Add('Dumb');
    ListBox1.Items.Add('SOB');
    TheList.Add('SOB');
    ListBox1.Items.Add('And');
    TheList.Add('And');
    ListBox1.Items.Add('My');
    TheList.Add('My');
    ListBox1.Items.Add('Own');
    TheList.Add('Own');
    ListBox1.Items.Add('Idiot');
    TheList.Add('Idiot');
   End;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 SKHeapSort1.USSort(ListBox1.Items.Count - 1);
 ListBox2.Items.Assign(TheList);
end;

function TForm1.SKHeapSort1SortLess(Index1, Index2: Integer): Boolean;
begin
   Result:= TheList.Strings[Index1] < TheList.Strings[Index2];
end;

procedure TForm1.SKHeapSort1SortSwap(Index1, Index2: Integer);
begin
   TheList.Exchange(Index1, Index2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
TheList := TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
TheList.Clear;
TheList.Free;
end;

end.
