{ This is a simple HeapSort component that hopefully makes it a bit easier
 to do heapsorts.
This component is freeware. Do with it what ever you want. but 
I will not be held liable for any damage it does (you have the source)

I must give credit to Ruud van der Ham
who posted the heapsort code on usenet.
his email is listed as rvdham@ect.nl
although I do not know if he is still
at that address.

For any questions or comments I can be reached at:
 robert@alpine.net }

unit SKHeapSort;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DsgnIntf;

Type TSortSwap=Procedure (Index1: LongInt; Index2: LongInt) Of Object; Far;
Type TSortLess=Function (Index1: LongInt; Index2: LongInt) : Boolean Of Object; Far;

type
  TAbout = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TSKHeapSort = class(TComponent)
  private
    FAbout: TAbout;
    FSortLess : TSortLess;
    FSortSwap : TSortSwap;
    FStartIndex : Integer;
  Protected
    Function SortLess(Index1: LongInt; Index2: LongInt): Boolean;
    Procedure SortSwap(Index1: LongInt; Index2: LongInt);
  public
    constructor Create(AOwner: TComponent); override;
    Function USSort(IndexHigh: LongInt): Byte;
  published
    property About: TAbout read FAbout write FAbout;
    Property StartIndex : Integer read FStartIndex write FStartIndex Default 0;
    Property OnSortLess : TSortLess read FSortLess write FSortLess;
    Property OnSortSwap : TSortSwap read FSortSwap write FSortSwap;
  end;

procedure Register;

implementation

Procedure TSKHeapSort.SortSwap(Index1: LongInt; Index2: LongInt); Far;
Begin

End;

Function TSKHeapSort.SortLess(Index1: LongInt; Index2: LongInt): Boolean; Far;
Begin

End;

Function TSKHeapSort.USSort(IndexHigh: LongInt): Byte;
 Label 99;
  Var
    L: LongInt;
    I: LongInt;
    J: LongInt;
    Length: LongInt;
    IR: LongInt;
    IRRA: LongInt;

  Begin
  Length:=IndexHigh-FStartIndex + 1;
  If Length>1 Then
    Begin
    L:=(Length Div 2)+1;
    IR:=Length;

    While TRUE Do
      Begin
      If L>1 Then
        Begin
        Dec(L);
        IRRA:=L;
        End
      Else
        Begin
        FSortSwap(IR + FStartIndex -1,1 + FStartIndex - 1);
        IRRA:=1;
        Dec(IR);
        If IR=1 Then
          Begin
          Goto 99;
          End;
        End;
      I:=L;
      J:=L+L;
      While J<=IR Do
        Begin
        If J<IR Then
          Begin
          If FSortLess(J + FStartIndex - 1,J + 1 + FStartIndex - 1) Then
            Begin
            Inc(J);
            End;
          End;
        If FSortLess(IRRA + FStartIndex - 1 ,J + FStartIndex - 1) Then
          Begin
          FSortSwap(I + FStartIndex - 1 ,J + FStartIndex - 1);
          IRRA:=J;
          I:=J;
          J:=J+J;
          End
        Else
          Begin
          J:=IR+1;
          End;
        End;
      End;
    99:
      End;

    USSort:=0;
End;

procedure TAbout.Edit;
begin
  Application.MessageBox('TSKHeapSort component v1.00 for Delphi 3.0. (C) 1998 Robert Jones. This component is freeware.',
                         'About TSKHeapSort Component', MB_OK + MB_ICONINFORMATION);
end;

function TAbout.GetAttributes: TPropertyAttributes;
begin
  Result:= [paMultiSelect, paDialog, paReadOnly];
end;

function TAbout.GetValue: string;
begin
  Result:= '(about)';
end;

constructor TSKHeapSort.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
//  ControlStyle:= ControlStyle + [csAcceptsControls];
end;

procedure Register;
begin
  RegisterComponents('Samples', [TSKHeapSort]);
  RegisterPropertyEditor(TypeInfo(TAbout), TSKHeapSort, 'ABOUT', TAbout);
end;

end.
